/////////////////////////////////////////////////////////////////////
// Class Creator Version 2.0.000 Copyrigth (C) Poul A. Costinsky 1994
///////////////////////////////////////////////////////////////////
// Header File WizArr.h
// class CWizArr
//
// 20/03/1996 19:10                             Author: Poul
///////////////////////////////////////////////////////////////////

#ifndef __CWizArr_H
#define __CWizArr_H

/////////////////////////////////////////////////////////////////////////////
template<class TYPE, class ARG_TYPE>
class CWizSimpleArr : public CArray<TYPE,ARG_TYPE>
{
public:
// Constructors:
	CWizSimpleArr ()
		{ SetSize(0, 16); }
// Destructor:
	~CWizSimpleArr () {}
public:
// Operations:
	TYPE& operator[](int i)
		{ return ElementAt(i); }
	const TYPE& operator[](int i) const 
		{ return const_cast<CWizSimpleArr*>(this)->ElementAt(i); }
};
/////////////////////////////////////////////////////////////////////////////
// class CWizArr
template<class TYPE, class ARG_TYPE>
class CWizArr : public CArray<TYPE,ARG_TYPE>
{
public:
// Constructors:
	CWizArr ()
		{ SetSize(0, 16); }
// Destructor:
	~CWizArr () {}
public:
// Operations:
	TYPE& operator[](int i)
		{ return ElementAt(i); }
	const TYPE& operator[](int i) const 
		{ return const_cast<CWizArr*>(this)->ElementAt(i); }
	void Swap(int i, int j)
		{
		ASSERT(i >= 0 && i < GetSize());
		ASSERT(j >= 0 && j < GetSize());
		ASSERT(i != j);
		TYPE tmp   = (*this)[i];
		(*this)[i] = (*this)[j];
		(*this)[j] = tmp;
		}
};

/////////////////////////////////////////////////////////////////////////////
template<class ARRAY_TYPE, class COMPARE_TYPE>
class CWizArrSort : public CWizSort
{
public:
	CWizArrSort(ARRAY_TYPE& Arr, COMPARE_TYPE& Comparer)
		: m_Arr (Arr) , m_Comparer (Comparer), CWizSort(Arr.GetSize())
			{}
protected:
	virtual void Swap    (int i, int j)
		{ m_Arr.Swap(i,j); }
	virtual int  Compare (int i, int j)
		{ return m_Comparer.Compare(m_Arr, i, j); }
	ARRAY_TYPE&		m_Arr;
	COMPARE_TYPE&	m_Comparer;
};
/////////////////////////////////////////////////////////////////////////////
// The function for sorting the array
template<class ARRAY_TYPE, class COMPARE_TYPE>
void Sort(ARRAY_TYPE& Arr, COMPARE_TYPE& Comparer)
{
	if (Arr.GetSize() > 1)
		{
		CWizArrSort<ARRAY_TYPE,COMPARE_TYPE> Sorter(Arr, Comparer);
		Sorter.Sort();
		}
}
/////////////////////////////////////////////////////////////////////////////
#endif // __CWizArr_H


